#include<stdio.h>
#include <string.h> 
#include <math.h>

#define nlin 100            
#define c   0.4             
#define omegastart 1.E-04
#define nomega 21
#define omegadens 10      
#define beta 30            
#define pi 3.141592654
#define epsilon 0.1
#define nphase 40


int seed=372067,volume=nlin, iz=1,np[500000],mz[250];
double norm,rnd;
int Lattic[nlin],Lattic1[nlin];
double current[nphase+1],curfct[nphase+1][nomega],cur,omega[nomega];
double energy[nlin];
int npar,ranpar,isteps,iphase,periods,preperiods,iperiod; 
double mu,phtime[nphase+1],time;
double deltasteps[nphase+1];
double xback,xfor,randir;
//------------------------------------
int XA0[nlin],XA[nlin],distX[nlin],posiAmXX,posP;
int iomega,iconf,endsymbol;
void outputfile();
FILE * fout;

int main() 
{
rndNum(seed);
for(i=0;i<500000; i++){
np[i]=0;
}
initialize();
Teilchenverteilung ();

for(iomega=0;iomega<nomega;++iomega){
cuurent_determination();
outputfile();
}

}
//------------------------------------
void rndNum(int seed)  //Kirkpatrick Stall Generator1
{
int jz,jzmax=2147483647,a0=16807;
norm=1.0/jzmax;
jz=2*seed+1;
for(i=0;i < 250;i++){
jz *= a0;
if(jz < 0)
jz += jzmax +1;
mz[i] = jz;
}}
//////////////////////////////////////////
void initialize() 
{
for(x = 0;x<(nlin);x++){
energy[x]=0;
}
mu=(1/(double)beta)*log((1-exp(-c*beta))/(exp(-1*c*beta)-exp(-1*beta)));
printf(" mu ist %f\n",mu);
for(i=1;i<=nomega;i++){
omega[i]=omegastart*pow(10.0,(double)i/(omegadens));
}
}
//////////////////////////////////////////
void Teilchenverteilung ()  //Hier werden Teilchen mit der Konzentration c der Fermiverteilung nach verteilt.
{
npar=0;
for(x = 0;x<(nlin);x++){
iz = (iz + 1) % 250;
mz[iz] ^= mz[(iz+103) % 250];
rnd = mz[iz]*norm;//printf(" rnd ist %f\n", rnd);
if(rnd<c){
Lattic[x]=npar;Lattic1[x]=1;
XA0[npar]=x; 
//printf("Das i=%d Teilchen sitzt am Punkt [%d]\n",npar,XA0[npar]);
npar++;
}//printf("Lattic1[%d] %d\n",x,Lattic1[x]);
}
//printf("Die Anzahl der Teilchen: %d\n",npar);
}
//////////////////////////////////////////
void cuurent_determination(); ()  //Hier werden Teilchen mit der Konzentration c der Fermiverteilung nach verteilt.
{
for(i=0; i<npar; i++){
XA[i]=XA0[i];distX[i]=0;  
}
phtime[0]=0.0;
for(i=1;i<=nphase;i++){
phtime[i]=2.0*pi*i/(nphase*omega[iomega]);//printf(" phtime[%d] %f\n",i,phtime[i]);
deltasteps[i]=npar*(phtime[i]-phtime[i-1]);//printf(" deltasteps[%d] %f\n",i,deltasteps[i]);
}
if(omega[iomega]<=1.0E-05)   periods=1;
else if(omega[iomega]<=1.0E-04)   periods=2;
else if(omega[iomega]<=1.0E-03)   periods=4;
else if(omega[iomega]<=1.0E-02)   periods=8;
else if(omega[iomega]<=1.0E-01)   periods=16;
else if(omega[iomega]<=1.0E+0)   periods=32;
else periods=64;
preperiods=periods/10;
for(iperiod=0,iperiod<preperiods+periods;++iperiod){/*$*/
if(iperiod==preperiods) 
for(i=1;i<=nphase;i++){
current[i]=0.0;
}
for(i=1;i<=nphase;i++){/*1*/
cur=0;
for(j=0;j<deltasteps[i];j++){/*2*/
     time=phtime[i-1]+(double) j/npar;//printf(" time %f\n",time);
      iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
      ranpar=int(rnd*(npar)); 
      //printf(" ranpar ist %d\n", ranpar); 
      posiAmXX=XA[ranpar];
      xback=(1-epsilon*sin(omega[iomega]*time))/2;//printf("xback %f\n",xback);
     
      iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
      randir=rnd;//printf(" randir ist %f\n", randir); 
   if(randir<=xback){  // Der Sprung nach rechts 
   if(posiAmXX<(nlin-1)){
   posP=Lattic1[posiAmXX+1];
   if(posP == 0){
   if(energy[posiAmXX]==energy[posiAmXX+1]){
   XA[ranpar]+=1;
   distX[ranpar]+=1;
   Lattic1[posiAmXX+1]=1;
   Lattic1[posiAmXX]=0;cur+=1;  
   }
else{
iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
if(exp(-beta*(energy[posiAmXX+1]-energy[posiAmXX]))>rnd){
XA[ranpar]+=1;
distX[ranpar]+=1;
Lattic1[posiAmXX+1]=1;
Lattic1[posiAmXX]=0;cur+=1; 
}
}
}}
if(posiAmXX==(nlin-1)){ // Periodische Randbedingung
posP=Lattic1[0];
if(posP == 0){
if(energy[nlin-1]==energy[0]){
XA[ranpar] = 0;
distX[ranpar]+=1;	
Lattic1[0]=1;
Lattic1[nlin-1]=0;cur+=1;
}
else{
iz = (iz + 1) % 250;
mz[iz] ^= mz[(iz+103) % 250];
rnd = mz[iz]*norm;
if(exp(-beta*(energy[0]-energy[nlin-1]))>rnd){
XA[ranpar] = 0;
distX[ranpar]+=1;	
Lattic1[0]=1;
Lattic1[nlin-1]=0;cur+=1;
}}
}}
//printf("bei t= %f bewegt sich das Teilchen iA= %d nach rechts und sitzt am Punkt (%d)\n",time,ranpar,XA[ranpar]);
}
//----------------------       
if(randir>xback){ // Der Sprung nach links

if(posiAmXX>0){
posP=Lattic1[posiAmXX-1];
if(posP == 0){
if(energy[posiAmXX]==energy[posiAmXX-1]){
XA[ranpar]-=1;
distX[ranpar]-=1;
Lattic1[posiAmXX-1]=1;
Lattic1[posiAmXX]=0;
}
else{
      iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
if(rnd<exp(-beta*(energy[posiAmXX-1]-energy[posiAmXX]))){
XA[ranpar]-=1;
distX[ranpar]-=1;
Lattic1[posiAmXX-1]=1;
Lattic1[posiAmXX]=0;
}}}}

if(posiAmXX==0){  // Periodische Randbedingung
posP=Lattic1[nlin-1];
if(posP == 0){
if(energy[0]==energy[nlin-1]){
XA[ranpar] = nlin-1;
distX[ranpar]-=1;
Lattic1[nlin-1]=1;
Lattic1[0]=0; 
}
else{
      iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
if(rnd<exp(-beta*(energy[nlin-1]-energy[0]))){
XA[ranpar] = nlin-1;
distX[ranpar]-=1;
Lattic1[nlin-1]=1;
Lattic1[0]=0; 
}
}
}}
//printf("bei t= %f bewegt sich das Teilchen iA= %d nach links und sitzt am Punkt (%d,)\n",time,ranpar,XA[ranpar]);
}
}/*2*/
current[i]=current[i]+cur;
//printf(" cur %d\n",cur);
}/*1*/
}/*$*/
for(i=1;i<=nphase;i++){
current[i]=current[i]/(double)(epsilon*(nlin)*periods*(phtime[i]-phtime[i-1]));
//printf(" current[%d] %f\n",i,current[i]);
}
}
////////////////////////////////////////////////////////////
void outputfile()
{
int l, t;
double iex, xfein=4.;
char name_x[300];
sprintf(name_x, outfile_x, c,beta,nlin);	// belegt Parameter
strcat(name_x, ".dat");			// haengt Endung an name_x

FILE * outfile;
outfile = fopen(name_x, "w");
fprintf(outfile,"Die Konzentration der Teilchen ist %f\n ",c);
fprintf(outfile,"Die inverse Temperatur ist %d\n ",beta);
fprintf(outfile,"Die Länge des kubischen Gitters ist %d\n ",nlin);
fprintf(outfile,"x-Achse: omega*t \n ");
fprintf(outfile,"y-Achse: J \n ");
fprintf(outfile,"/////////////////////////////////////////////\n ");
for(j=1;j<=nomega;j++){
fprintf(outfile,"& omega=%1e\n ",omega[j]);
for(i=1;i<=nphase;i++){
fprintf(outfile,"%f %f\n ",2.0*pi*(double)i/nphase,curfct[i][j]);
}
}
  

fclose(outfile);
}
///////////////////////////////////////////////////////////////////
