/**********************************************************************/
/******


Dieses Program wurde zur Berechnung 
der Aktivierungsenergie der Diffusionskonstante durch MCS Simulationen (Metropolis) in 3-dim. System mit 
mit gleichverteilter Energien erstellt. 


********/
/**********************************************************************/







#include<stdio.h>
#include <string.h> 
#include <math.h> 



#define nlin 30                // Die Länge des Gitters
#define c   0.1              //  Die Konzentration der Teilchen   
#define Zeitmax 100000      //   Die Anzahl der Monte-Carlo Simulationsschritte 
#define beta 14           //    Beta=1/(K_B*T)
#define K   1              //     Die Anzahl der Konfigurationen

#define outfile_x "Diffusion_3D_GV_Energien_%f_%d_%d_%d"

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//generator
int seed=372067; 
int iz=1;
int np[500000],mz[250];
double norm,rnd;
int x,y,z,i,j,k;
//------------------------------------
int Lattic[nlin][nlin][nlin],Lattic1[nlin][nlin][nlin];
double energy[nlin][nlin][nlin];
int npar,ranpar,randir; double mu;
//------------------------------------
int XA0[nlin*nlin*nlin],XA[nlin*nlin*nlin],YA0[nlin*nlin*nlin],
    YA[nlin*nlin*nlin],distX[nlin*nlin*nlin],distY[nlin*nlin*nlin],distZ[nlin*nlin*nlin],
    ZA0[nlin*nlin*nlin],ZA[nlin*nlin*nlin];
//------------------------------------
double Zeit,R[K][Zeitmax],RR[Zeitmax];
int    ZeitM, ZeitInt;
int    posiAmXX,posiAmYY,posiAmZZ,posP;
int   jumps;
void outputfile();
FILE * fout;
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
void rndNum(int seed)  //Kirkpatrick Stall Generator1
{
int jz,jzmax=2147483647,a0=16807;
norm=1.0/jzmax;
jz=2*seed+1;
for(i=0;i < 250;i++){
jz *= a0;
if(jz < 0)
jz += jzmax +1;
mz[i] = jz;
}}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
void Struktur () //Hier jedem Gitterpunkt wird zufällig eine gleichverteilte Zufallzahl zugeordnet.
{
for(z = 0;z<(nlin);z++){  
for(y = 0;y<(nlin);y++){                                                                                
for(x = 0;x<(nlin);x++){
iz = (iz + 1) % 250;
mz[iz] ^= mz[(iz+103) % 250];
rnd = mz[iz]*norm;//printf("  %f\n", rnd);
energy[z][y][x]=rnd;//printf("energy[%d][%d] %f\n",y,x,energy[y][x]);   
}}}
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void Teilchenverteilung ()  //Hier werden Teilchen mit der Konzentration c der Fermiverteilung nach verteilt.
{
npar=0;
for(z = 0;z<(nlin);z++){
for(y = 0;y<(nlin);y++){                                                                                
for(x = 0;x<(nlin);x++){
iz = (iz + 1) % 250;
mz[iz] ^= mz[(iz+103) % 250];
rnd = mz[iz]*norm;
if(rnd<(double)(1/(exp((energy[z][y][x]-mu)*beta)+1))){
Lattic[z][y][x]=npar;Lattic1[z][y][x]=1;
XA0[npar]=x; YA0[npar]=y;ZA0[npar]=z;
//printf("Das i=%d Teilchen sitzt am Punkt [%d][%d]\n",npar,YA0[npar],XA0[npar]);
npar++;
}}}}
printf("Die Anzahl der Teilchen: %d\n",npar);
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void outputfile()
{
int l, t;
double iex, xfein=4.;
char name_x[300];
sprintf(name_x, outfile_x, c,beta,K,nlin);	// belegt Parameter
strcat(name_x, ".dat");			// haengt Endung an name_x

FILE * outfile;
outfile = fopen(name_x, "w");

  
for(ZeitInt=1;ZeitInt <= 12; ZeitInt++){
fprintf(outfile,"%15f  %15f\n ",double(ZeitInt),RR[ZeitInt-1]);
}
l=15;
for(ZeitInt=12;ZeitInt < Zeitmax; ZeitInt++){
iex = double(l)/xfein;
t = (int) pow(2.,iex);
if(ZeitInt==t){
fprintf(outfile,"%15f  %15f\n ",double(ZeitInt),RR[ZeitInt-1]);
l++;}}
fclose(outfile);
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX Hauptfunktion XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int main() 
{
for(k=0;k<K;k++){  //Schleife der Konfigurationen  
seed=372067+2*k;
rndNum(seed);
for(i=0;i<500000; i++){
np[i]=0;
}
//-----------------------------------------------
Struktur ();
//-----------------------------------------------
mu=(1/(double)beta)*log((1-exp(-c*beta))/(exp(-1*c*beta)-exp(-1*beta)));
printf(" mu ist %f\n",mu);
//-----------------------------------------------
Teilchenverteilung ();
//-----------------------------------------------
for(i=0; i<npar; i++){
XA[i]=XA0[i];distX[i]=0;  
YA[i]=YA0[i];distY[i]=0;
ZA[i]=ZA0[i];distZ[i]=0;
}
//-----------------------------------------------
jumps=0; // Bestimmung der mittlere Sprungrate
for(ZeitInt=1;ZeitInt<Zeitmax;ZeitInt++){
R[k][ZeitInt-1]=0.0;
}
ZeitInt=1;
Zeit=0;
while(Zeit<=Zeitmax){
ZeitM=Zeit;
      iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
      ranpar=int(rnd*(npar)); // Hier wird zufällig ein Teilchen ausgewählt.
    //printf(" ranpar ist %d\n", ranpar); 
      posiAmXX=XA[ranpar];
      posiAmYY=YA[ranpar];
      posiAmZZ=ZA[ranpar];
      iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
     rnd = mz[iz]*norm;
     randir=(int)(6*rnd);// Hier wird zufällig eine Sprungsrichtung ausgewählt.
   
                  
//----------------------
if(randir==0){  // Der Sprung nach rechts 
if(posiAmXX<(nlin-1)){
posP=Lattic1[posiAmZZ][posiAmYY][posiAmXX+1];
if(posP == 0){
// Metropolis
if(energy[posiAmZZ][posiAmYY][posiAmXX]>energy[posiAmZZ][posiAmYY][posiAmXX+1]){
XA[ranpar]+=1;
distX[ranpar]+=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX+1]=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX]=0;jumps+=1;  
}
else{
iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
if(exp(-beta*(energy[posiAmZZ][posiAmYY][posiAmXX+1]-energy[posiAmZZ][posiAmYY][posiAmXX]))>rnd){
XA[ranpar]+=1;
distX[ranpar]+=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX+1]=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX]=0;jumps+=1; 
}
}
}}
if(posiAmXX==(nlin-1)){ // Periodische Randbedingung
posP=Lattic1[posiAmZZ][posiAmYY][0];
if(posP == 0){
if(energy[posiAmZZ][posiAmYY][nlin-1]>energy[posiAmZZ][posiAmYY][0]){
XA[ranpar] = 0;
distX[ranpar]+=1;	
Lattic1[posiAmZZ][posiAmYY][0]=1;
Lattic1[posiAmZZ][posiAmYY][nlin-1]=0;jumps+=1;
}
else{
iz = (iz + 1) % 250;
mz[iz] ^= mz[(iz+103) % 250];
rnd = mz[iz]*norm;
if(exp(-beta*(energy[posiAmZZ][posiAmYY][0]-energy[posiAmZZ][posiAmYY][nlin-1]))>rnd){
XA[ranpar] = 0;
distX[ranpar]+=1;	
Lattic1[posiAmZZ][posiAmYY][0]=1;
Lattic1[posiAmZZ][posiAmYY][nlin-1]=0;jumps+=1;
}}
}}
//printf("bei t= %f bewegt sich das Teilchen iA= %d nach rechts und sitzt am Punkt (%d,%d)\n",Zeit,ranpar,YA[ranpar],XA[ranpar]);
}
//----------------------
 if(randir==1){ // Der Sprung nach links

if(posiAmXX>0){
posP=Lattic1[posiAmZZ][posiAmYY][posiAmXX-1];
if(posP == 0){
if(energy[posiAmZZ][posiAmYY][posiAmXX]>energy[posiAmZZ][posiAmYY][posiAmXX-1]){
XA[ranpar]-=1;
distX[ranpar]-=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX-1]=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX]=0;jumps+=1; 
}
else{
      iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
if(rnd<exp(-beta*(energy[posiAmZZ][posiAmYY][posiAmXX-1]-energy[posiAmZZ][posiAmYY][posiAmXX]))){
XA[ranpar]-=1;
distX[ranpar]-=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX-1]=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX]=0;jumps+=1; 
}}}}

if(posiAmXX==0){  // Periodische Randbedingung
posP=Lattic1[posiAmZZ][posiAmYY][nlin-1];
if(posP == 0){
if(energy[posiAmZZ][posiAmYY][0]>energy[posiAmZZ][posiAmYY][nlin-1]){
XA[ranpar] = nlin-1;
distX[ranpar]-=1;
Lattic1[posiAmZZ][posiAmYY][nlin-1]=1;
Lattic1[posiAmZZ][posiAmYY][0]=0;jumps+=1; 
}
else{
      iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
if(rnd<exp(-beta*(energy[posiAmZZ][posiAmYY][nlin-1]-energy[posiAmZZ][posiAmYY][0]))){
XA[ranpar] = nlin-1;
distX[ranpar]-=1;
Lattic1[posiAmZZ][posiAmYY][nlin-1]=1;
Lattic1[posiAmZZ][posiAmYY][0]=0;jumps+=1; 
}
}
}}
//printf("bei t= %f bewegt sich das Teilchen iA= %d nach links und sitzt am Punkt (%d,%d)\n",Zeit,ranpar,YA[ranpar],XA[ranpar]);



}
//----------------------
if(randir==2){ // Der Sprung nach vorne 
if(posiAmYY<(nlin-1)){
posP=Lattic1[posiAmZZ][posiAmYY+1][posiAmXX];
if(posP == 0){
if(energy[posiAmZZ][posiAmYY][posiAmXX]>energy[posiAmZZ][posiAmYY+1][posiAmXX]){
YA[ranpar]+=1;
distY[ranpar]+=1;
Lattic1[posiAmZZ][posiAmYY+1][posiAmXX]=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX]=0;jumps+=1;  
}
else{
      iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
if(exp(-beta*(energy[posiAmZZ][posiAmYY+1][posiAmXX]-energy[posiAmZZ][posiAmYY][posiAmXX]))>rnd){
YA[ranpar]+=1;
distY[ranpar]+=1;
Lattic1[posiAmZZ][posiAmYY+1][posiAmXX]=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX]=0;jumps+=1; 
}
}
}}
if(posiAmYY==(nlin-1)){  // Periodische Randbedingung
posP=Lattic1[posiAmZZ][0][posiAmXX];
if(posP == 0){
if(energy[posiAmZZ][nlin-1][posiAmXX]>energy[posiAmZZ][0][posiAmXX]){
YA[ranpar] = 0;
distY[ranpar]+=1;	
Lattic1[posiAmZZ][0][posiAmXX]=1;
Lattic1[posiAmZZ][nlin-1][posiAmXX]=0;jumps+=1;
}
else{
iz = (iz + 1) % 250;
mz[iz] ^= mz[(iz+103) % 250];
rnd = mz[iz]*norm;
if(exp(-beta*(energy[posiAmZZ][0][posiAmXX]-energy[posiAmZZ][nlin-1][posiAmXX]))>rnd){
YA[ranpar] = 0;
distY[ranpar]+=1;	
Lattic1[posiAmZZ][0][posiAmXX]=1;
Lattic1[posiAmZZ][nlin-1][posiAmXX]=0;jumps+=1;
}}
}}
//printf("bei t= %f bewegt sich das Teilchen iA= %d nach vorne und sitzt am Punkt (%d,%d)\n",Zeit,ranpar,YA[ranpar],XA[ranpar]);
}
//----------------------
if(randir==3){ // Der Sprung nach hinter 
if(posiAmYY>0){
posP=Lattic1[posiAmZZ][posiAmYY-1][posiAmXX];
if(posP == 0){
if(energy[posiAmZZ][posiAmYY][posiAmXX]>energy[posiAmZZ][posiAmYY-1][posiAmXX]){
YA[ranpar]-=1;
distY[ranpar]-=1;
Lattic1[posiAmZZ][posiAmYY-1][posiAmXX]=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX]=0;jumps+=1; 
}
else{
      iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
if(rnd<exp(-beta*(energy[posiAmZZ][posiAmYY-1][posiAmXX]-energy[posiAmZZ][posiAmYY][posiAmXX]))){
YA[ranpar]-=1;
distY[ranpar]-=1;
Lattic1[posiAmZZ][posiAmYY-1][posiAmXX]=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX]=0;jumps+=1; 
}}}}

if(posiAmYY==0){ // Periodische Randbedingung
posP=Lattic1[posiAmZZ][nlin-1][posiAmXX];
if(posP == 0){
if(energy[posiAmZZ][0][posiAmXX]>energy[posiAmZZ][nlin-1][posiAmXX]){
YA[ranpar] = nlin-1;
distY[ranpar]-=1;
Lattic1[posiAmZZ][nlin-1][posiAmXX]=1;
Lattic1[posiAmZZ][0][posiAmXX]=0;jumps+=1; 
}
else{
iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
if(rnd<exp(-beta*(energy[posiAmZZ][nlin-1][posiAmXX]-energy[posiAmZZ][0][posiAmXX]))){
YA[ranpar] = nlin-1;
distY[ranpar]-=1;
Lattic1[posiAmZZ][nlin-1][posiAmXX]=1;
Lattic1[posiAmZZ][0][posiAmXX]=0;jumps+=1; 
}
}
}}
//printf("bei t= %f bewegt sich das Teilchen iA= %d nach hinter und sitzt am Punkt (%d,%d)\n",Zeit,ranpar,YA[ranpar],XA[ranpar]);

}
//----------------------
if(randir==4){  // Der Sprung nach oben 
if(posiAmZZ<(nlin-1)){
posP=Lattic1[posiAmZZ+1][posiAmYY][posiAmXX];
if(posP == 0){
if(energy[posiAmZZ][posiAmYY][posiAmXX]>energy[posiAmZZ+1][posiAmYY][posiAmXX]){
ZA[ranpar]+=1;
distZ[ranpar]+=1;
Lattic1[posiAmZZ+1][posiAmYY][posiAmXX]=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX]=0;jumps+=1;  
}
else{
iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
if(exp(-beta*(energy[posiAmZZ+1][posiAmYY][posiAmXX]-energy[posiAmZZ][posiAmYY][posiAmXX]))>rnd){
ZA[ranpar]+=1;
distZ[ranpar]+=1;
Lattic1[posiAmZZ+1][posiAmYY][posiAmXX]=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX]=0;jumps+=1; 
}
}
}}
if(posiAmZZ==(nlin-1)){  //Periodische Randbedingung
posP=Lattic1[0][posiAmYY][posiAmXX];
if(posP == 0){
if(energy[nlin-1][posiAmYY][posiAmXX]>energy[0][posiAmYY][posiAmXX]){
ZA[ranpar] = 0;
distZ[ranpar]+=1;	
Lattic1[0][posiAmYY][posiAmXX]=1;
Lattic1[nlin-1][posiAmYY][posiAmXX]=0;jumps+=1;
}
else{
iz = (iz + 1) % 250;
mz[iz] ^= mz[(iz+103) % 250];
rnd = mz[iz]*norm;
if(exp(-beta*(energy[0][posiAmYY][posiAmXX]-energy[nlin-1][posiAmYY][posiAmXX]))>rnd){
ZA[ranpar] = 0;
distZ[ranpar]+=1;	
Lattic1[0][posiAmYY][posiAmXX]=1;
Lattic1[nlin-1][posiAmYY][posiAmXX]=0;jumps+=1;
}}
}}
//printf("bei t= %f bewegt sich das Teilchen iA= %d nach oben und sitzt am Punkt (%d,%d)\n",Zeit,ranpar,YA[ranpar],XA[ranpar]);
}
//----------------------
if(randir==5){ // Der Sprung nach unten 
if(posiAmZZ>0){
posP=Lattic1[posiAmZZ-1][posiAmYY][posiAmXX];
if(posP == 0){
if(energy[posiAmZZ][posiAmYY][posiAmXX]>energy[posiAmZZ-1][posiAmYY][posiAmXX]){
ZA[ranpar]-=1;
distZ[ranpar]-=1;
Lattic1[posiAmZZ-1][posiAmYY][posiAmXX]=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX]=0;jumps+=1; 
}
else{
      iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
if(rnd<exp(-beta*(energy[posiAmZZ-1][posiAmYY][posiAmXX]-energy[posiAmZZ][posiAmYY][posiAmXX]))){
ZA[ranpar]-=1;
distZ[ranpar]-=1;
Lattic1[posiAmZZ-1][posiAmYY][posiAmXX]=1;
Lattic1[posiAmZZ][posiAmYY][posiAmXX]=0;jumps+=1; 
}}}}

if(posiAmZZ==0){ //Periodische Randbedingung
posP=Lattic1[posiAmZZ][nlin-1][posiAmXX];
if(posP == 0){
if(energy[0][posiAmYY][posiAmXX]>energy[nlin-1][posiAmYY][posiAmXX]){
ZA[ranpar] = nlin-1;
distZ[ranpar]-=1;
Lattic1[nlin-1][posiAmYY][posiAmXX]=1;
Lattic1[0][posiAmYY][posiAmXX]=0;jumps+=1; 
}
else{
iz = (iz + 1) % 250;
      mz[iz] ^= mz[(iz+103) % 250];
      rnd = mz[iz]*norm;
if(rnd<exp(-beta*(energy[nlin-1][posiAmYY][posiAmXX]-energy[0][posiAmYY][posiAmXX]))){
ZA[ranpar] = nlin-1;
distZ[ranpar]-=1;
Lattic1[nlin-1][posiAmYY][posiAmXX]=1;
Lattic1[0][posiAmYY][posiAmXX]=0;jumps+=1;  
}
}
}}
//printf("bei t= %f bewegt sich das Teilchen iA= %d nach unten und sitzt am Punkt (%d,%d)\n",Zeit,ranpar,YA[ranpar],XA[ranpar]);

}
//----------------------
Zeit+=1/double(npar);//printf("Der zeitschritt %f\n",Zeit);
if(ZeitM<ZeitInt && Zeit>=ZeitInt){
for(i=0;i<npar;i++){

R[k][ZeitInt-1]+=((distX[i]*distX[i])+(distY[i]*distY[i])+(distZ[i]*distZ[i]))/double(npar);
}
//printf("%f\n",R[k][ZeitInt-1]);
ZeitInt+=1;
}
}//Zeit
printf(" Die mittlere Sprungrate %15f\n",jumps/double(npar*Zeitmax));
}
for(ZeitInt=1; ZeitInt<Zeitmax; ZeitInt++){  
for(k=0;k<K;k++){
RR[ZeitInt-1]+=R[k][ZeitInt-1]/K;}}   
outputfile();
return 0;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


