#include<stdio.h>
#include <string.h> 
#include <math.h>
using namespace std;


void labelmin_sw(int z, int y, int x, int south, int west);
void labelmin_dw(int z, int y, int x, int down, int west);
void labelmin_ds(int z, int y, int x, int down, int south);
void neighbours_dsw(int z,int y,int x,int down,int south,int west);
void labelmin_dsw(int z, int y, int x, int down, int south, int west);
int intmax(int valuea,int valueb);
int intmin(int valuea,int valueb);
int proper( int label );
int findmin(int a, int b, int c );
void printlabel();
int newcluster(int ncluster, int z, int y, int x);
void initlabel();
void calclabel();
void neighbours_sw(int z, int y, int x, int south, int west);
void neighbours_ds(int z, int y, int x, int south, int west);
void neighbours_dw(int z, int y, int x, int south, int west); 
void Distribution_Unites();
void Distribution_Concentration();
void Distribution_Charges();
void Initialization();
void Start_Zufallszahlen(int seed);
void Gauss_Verteilung();

#define  L         100                         
#define  nlin2     51                         

#define  CT        0.5                      
#define  X         0.1            

#define  sigma     0.6

#define U         0.385
#define Nc         16 



/**************************************** Netzwerkeinheitenmodell *************************************************/
int      P_1[L+1][L+1][L+1],P_2[L+1][L+1][L+1],P_3[L+1][L+1][L+1];        /* Phosphat-Einheiten  */
int      Te_1[L+1][L+1][L+1],Te_4[L+1][L+1][L+1];                        /* Tellurit-Einheiten  */
float    C_P1,C_P2,C_P3,C_Te1,C_Te4;                                    /*  Experimentelle kozentrationen der oben definierten Einheiten  */
double   Q[L][L][L];                                                   /*  Akumulierte Ladung  */
int      jG1,jG2,jG3;
/*****************************************************Der neuen Konzept (Xi-Methode)******************************/
double     Energie[nlin2][nlin2][nlin2];   /* Die Platzenergien */
int        y,x,z,i,j,k; 
int        nc;
/**************************************************** mu_Bestimmung *********************************************/
int NT;                   /* Anzahl der Teilchen  N= L^3 * CL */
double mu;
/* Heapsort Code */
float data[(nlin2)*(nlin2)*(nlin2)], temp;
int  v, root;
/***************************************************** Barriernetzwerk **********************************************/
double Bindung_X[nlin2][nlin2][nlin2],Bindung_Y[nlin2][nlin2][nlin2],Bindung_Z[nlin2][nlin2][nlin2];
int struc_help1[nlin2][nlin2][nlin2],struc_help2[nlin2][nlin2][nlin2],struc_help3[nlin2][nlin2][nlin2];
/***************************************************** Perkolation **********************************************/
int ll,lll,J,label,l;
int Xmax,Hmax,Hmax1,hhhh_x,hhhh_y,hhhh_z,h[nlin2*nlin2*nlin2];
int summe_c[Nc],summe_cl; 
int summe_x,summe_y,summe_z;
int cl[nlin2][nlin2][nlin2];
/***************************************************** Zufallzahlen **********************************************/
#define Kirkpatrick  iz = (iz + 1) % 250;  mz[iz] ^= mz[(iz+103) % 250];   
int seed=372067,iz=1,np[500000],mz[250],lm;
double norm;
double rnd1,rnd2,rnd3;
int    rnd4,rnd5,rnd6;
/***************************************************** Gausszufallzahlen *****************************************/
double Jdimax;
int Jmult = 16807, Jiadd = 2147483647,Jmz[250],Jitoz;
double x1[L*L*L];
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
void rndNum(int seed)  //Kirkpatrick Stall Generator1
{
int jz,jzmax=2147483647,a0=16807;
norm=1.0/jzmax;
jz=2*seed+1;
for(i=0;i < 250;i++){
jz *= a0;
if(jz < 0)
jz += jzmax +1;
mz[i] = jz;
}}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
void calclabel()
{
  int x,y,z;
  int ncluster = 0; 
  int down=0,west=0,south=0;

for(z = 0;z <(nlin2);z++){
for(y = 0;y <(nlin2);y++){           
for(x = 0;x <(nlin2);x++){
           cl[z][y][x] = 0;
     }}}
x = 0;
if( Energie[0][0][0]<0 )
ncluster = newcluster(ncluster,0, 0, 0);


for(z = 1; z <(nlin2);z++){
       if( Energie[z][0][x]<0 ){
            west = z -1;
            if((Energie[west][0][x]<0)&&(struc_help3[z-1][0][x]==1))
               cl[z][0][x] = cl[west][0][x]; 
            else 
               ncluster = newcluster( ncluster,z,  0, x);
       }
  }

  for(y = 1; y <(nlin2);y++){
       if(Energie[0][y][x]<0){
          south = y - 1;
          if((Energie[0][south][x]<0)&&(struc_help2[0][y-1][x]==1))
             cl[0][y][x] = cl[0][south][x];
          else
             ncluster = newcluster( ncluster,0,y , x);
       }
       for(z = 1; z<(nlin2);z++){
          if(Energie[z][y][x]<0){
             south =y - 1;
             west = z - 1;
                           if((struc_help3[z-1][y][x]==0)&&(struc_help2[z][y-1][x]==0))
                                             ncluster = newcluster(ncluster,z, y, x);

                            if((struc_help3[z-1][y][x]==1)&&(struc_help2[z][y-1][x]==0))
                                          cl[z][y][x] = cl[west][y][x];

                                                                                              
                               if((struc_help3[z-1][y][x]==0)&&(struc_help2[z][y-1][x]==1))

                                 cl[z][y][x] =cl[z][south][x];


                               if((struc_help3[z-1][y][x]==1)&&(struc_help2[z][y-1][x]==1))
                                          neighbours_sw(z, y, x, south, west);
          }
       }
  }



 for(x = 1; x <(nlin2); x++){
      if(Energie[0][0][x] < 0){
         down = x - 1;
         if((Energie[0][0][down] < 0)&(struc_help1[0][0][x-1]==1))
            cl[0][0][x] = cl[0][0][down];
         
         else
            ncluster = newcluster(ncluster,0, 0, x);
         
      }


      for(z = 1; z <(nlin2);z++){
          if(Energie[z][0][x] < 0){
             down = x - 1;
             west = z - 1;
                           if((struc_help3[z-1][0][x]==0)&&(struc_help1[z][0][x-1]==0))
                                             ncluster = newcluster(ncluster,z, 0, x);

                            if((struc_help3[z-1][0][x]==1)&&(struc_help1[z][0][x-1]==0))
                                          cl[z][0][x] = cl[west][0][x];

                                                                                              
                               if((struc_help3[z-1][0][x]==0)&&(struc_help1[z][0][x-1]==1))

                                 cl[z][0][x] =cl[z][0][down];


                               if((struc_help3[z-1][0][x]==1)&&(struc_help1[z][0][x-1]==1))
                                          neighbours_dw(z, 0, x, down, west);
          }
      }

      for(y = 1;y <(nlin2);y++){
         if(Energie[0][y][x] < 0){
             down  =  x - 1;
             south = y - 1;
                                if((struc_help1[0][y][x-1]==0)&&(struc_help2[0][y-1][x]==0))
                                             ncluster = newcluster(ncluster,0, y, x);

                                if((struc_help1[0][y][x-1]==1)&&(struc_help2[0][y-1][x]==0))
                                          cl[0][y][x] = cl[0][y][down];

                                                                                              
                               if((struc_help1[0][y][x-1]==0)&&(struc_help2[0][y-1][x]==1))

                                 cl[0][y][x] =cl[0][south][x];


                               if((struc_help1[0][y][x-1]==1)&&(struc_help2[0][y-1][x]==1))
                                neighbours_ds(0, y, x, down, south);
             
         }
         for(z = 1;z <(nlin2);z++){
            if(Energie[z][y][x] < 0){
               down = x-1;
               south = y-1;
               west = z-1;

if(((struc_help3[z-1][y][x]==0)&&(struc_help2[z][y-1][x]==0))&&(struc_help1[z][y][x-1]==0))
ncluster = newcluster(ncluster,z,y,x);

else{

if((struc_help3[z-1][y][x]==1)&&(struc_help2[z][y-1][x]==0)&&(struc_help1[z][y][x-1]==0)){
cl[z][y][x] = cl[west][y][x];}       


if((struc_help3[z-1][y][x]==0)&&(struc_help2[z][y-1][x]==1)&&(struc_help1[z][y][x-1]==0)){               
cl[z][y][x] =cl[z][south][x];}


if(((struc_help3[z-1][y][x]==0)&&(struc_help2[z][y-1][x]==0))&&(struc_help1[z][y][x-1]==1)){                                  
cl[z][y][x] =cl[z][y][down];}


if((struc_help3[z-1][y][x]==1)&&(struc_help2[z][y-1][x]==1)&&(struc_help1[z][y][x-1]==0)){
neighbours_sw(z, y, x, south, west);}


if((struc_help3[z-1][y][x]==1)&&(struc_help2[z][y-1][x]==0)&&(struc_help1[z][y][x-1]==1)){                                   
neighbours_dw(z, y, x, down, west);}


if(((struc_help3[z-1][y][x]==0)&&(struc_help2[z][y-1][x]==1))&&(struc_help1[z][y][x-1]==1)){
neighbours_ds(z, y, x, down, south);}


if(((struc_help3[z-1][y][x]==1)&&(struc_help2[z][y-1][x]==1))&&(struc_help1[z][y][x-1]==1)){                                   
neighbours_dsw(z, y, x, down, south, west);}
}

               
            }
         }
      }
      
  }








}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int newcluster(int ncluster, int z, int y, int x)  // fuer neue cluster
{
   ncluster += 1;

   cl[z][y][x] = ncluster;

   np[ncluster-1] = 0;

   return ncluster;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void neighbours_sw(int z, int y, int x, int south, int west)  // nachbarn sw
{

   if( Energie[west][y][x] * Energie[z][south][x] > 0 ){
         labelmin_sw( z,y, x, south, west);
         return;
   }
   else if( cl[z][south][x] > 0  ){
       cl[z][y][x] = cl[z][south][x];
       return;
   }
   else
       cl[z][y][x] = cl[west][y][x];

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void neighbours_dw(int z, int y, int x, int down, int west) // nachbarn dw
{

   if( Energie[z][y][down] * Energie[west][y][x] > 0 ){
         labelmin_dw( z, y, x, down, west);
         return;
   }
   else if( cl[z][y][down] > 0  ){
       cl[z][y][x] = cl[z][y][down];
       return;
   }
   else
       cl[z][y][x] = cl[west][y][x];

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void neighbours_ds(int z, int y, int x, int down, int south)  // nachbarn ds
{

   if( Energie[z][y][down] * Energie[z][south][x] > 0 ){
         labelmin_ds( z, y, x, down, south);
         return;
   }
   else if( cl[z][y][down] > 0  ){
       cl[z][y][x]=cl[z][y][down];
       return;
   }
   else
       cl[z][y][x] = cl[z][south][x];

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void labelmin_sw(int z, int y, int x, int south, int west) // minimum aus zwei label sw
{
   int label1=0, label2=0;
   int lmax=0 ,lmin=0;


   if( cl[west][y][x] == cl[z][south][x] )
       cl[z][y][x] = cl[west][y][x];
   else
   {
       label1 = cl[west][y][x];
       label2 = cl[z][south][x];

       label1 = proper(label1);
       label2 = proper(label2);

       lmax = intmax( label1,label2 );
       lmin = intmin( label1,label2 );

       cl[z][y][x] = lmin;

       if(lmax != lmin)
          np[lmax-1] = lmin;
   }

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void labelmin_dw(int z, int y, int x, int down, int west) // minimum aus zwei label dw
{
   int label1=0, label2=0;
   int lmax=0 ,lmin=0;

   if( cl[z][y][down] == cl[west][y][x] )
       cl[z][y][x] = cl[west][y][x];
   else
   {
       label1 = cl[z][y][down];
       label2 = cl[west][y][x];

       label1 = proper(label1);
       label2 = proper(label2);

       lmax = intmax( label1,label2 );
       lmin = intmin( label1,label2 );

       cl[z][y][x] = lmin;

       if(lmax != lmin)
          np[lmax-1] = lmin;
   }

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void labelmin_ds(int z, int y, int x, int down, int south) // minimum aus zwei label ds
{
   int label1=0, label2=0;
   int lmax=0 ,lmin=0;

   if( cl[z][y][down] == cl[z][south][x] )
       cl[z][y][x] = cl[z][south][x];
   else
   {
       label1 = cl[z][y][down];
       label2 = cl[z][south][x];

       label1 = proper(label1);
       label2 = proper(label2);

       lmax = intmax( label1,label2 );
       lmin = intmin( label1,label2 );

       cl[z][y][x] = lmin;

       if(lmax != lmin)
          np[lmax-1] = lmin;
   }

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void neighbours_dsw(int z, int y ,int x ,int down ,int south ,int west)  // ermittelt nachbarn dsw
{
   if(Energie[z][y][down] * Energie[z][south][x] * Energie[west][y][x] > 0){
         labelmin_dsw( z, y, x, down, south, west);
         return;
   }
   else if(Energie[west][y][x] * Energie[z][south][x] > 0){
        labelmin_sw(z, y, x, south, west);
         return;
   }
   else if(Energie[z][y][down] * Energie[west][y][x] > 0){
         labelmin_dw(z, y, x, down, west);
         return;
   }
   else if(Energie[z][y][down] * Energie[z][south][x] > 0){
         labelmin_ds(z, y, x, down, south);
         return;
   }
   else if(cl[z][y][down] > 0){
       cl[z][y][x] = cl[z][y][down];
       return;
   }
   else if(cl[z][south][x] > 0 ){
       cl[z][y][x] = cl[z][south][x];
       return;
   }
   else{
       cl[z][y][x] = cl[west][y][x];
   }
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void labelmin_dsw(int z, int y, int x, int down, int south, int west) // sucht minimum aus drei label d,s,w
{
   int label1=0, label2=0, label3=0;
   int lmin=0;


   if((cl[z][y][down] == cl[z][south][x]) && (cl[z][y][down] == cl[west][y][x]) )
       cl[z][y][x] = cl[z][south][x];
   else
   {
       label1 = cl[z][y][down];
       label2 = cl[z][south][x];
       label3 = cl[west][y][x];

       label1 = proper(label1);
       label2 = proper(label2);
       label3 = proper(label3);

       lmin = findmin(label1, label2, label3);

       cl[z][y][x] = lmin;

       if(label1 != lmin)
          np[label1-1] = lmin;
       if(label2 != lmin)
          np[label2-1] = lmin;
       if(label3 != lmin)
          np[label3-1] = lmin;

   }

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int proper(int label)  // sucht proper label
{

   while( np[label -1] != 0 ){
      label = np[label -1];
  }

  return label;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int intmax(int valuea,int valueb)
{
    if(valuea < valueb)
       return valueb;
    else 
       return valuea;
}
//------------------------------------------------------
int intmin(int valuea,int valueb)
{
    if(valuea < valueb)
       return valuea;
    else 
       return valueb;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int findmin(int a, int b, int c )  //findet minimum aus a,b,c
{
   int min;

   if((a <= b && b <= c) || (a <= c && c <= b))
     min = a;
   else if((b <= a && a <= c) || (b <= c && c <= a))
     min = b;
   else 
     min = c;

   return min;

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX Hauptfunktion XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int main() 
{

double P_inf[Nc];
for(nc=0;nc<Nc;nc++){  
summe_c[nc]=0;P_inf[nc]=0;
}
printf("X %f\n",X);printf("U %f\n",U);
for(nc=0;nc<30;nc++){   /* konfiguration-Schleife */
seed=372067+2*nc;//printf("seed %d\n",seed);
rndNum(seed);
for(i=0;i<500000; i++){np[i]=0;}


/******************** Netzwerkeinheitenmodell ******************/
Initialization();
Distribution_Concentration();
Distribution_Unites();
Distribution_Charges();
for(z = 0;z<(L/2)+1;z++){  
for(y = 0;y<(L/2)+1;y++){
for(x = 0;x<(L/2)+1;x++){
//printf("Q[%d][%d][%d] %f\n",2*z,2*y,2*x,Q[2*z][2*y][2*x]);
}}}
for(z = 0;z<(L/2)+1;z++){  
for(y = 0;y<(L/2)+1;y++){
for(x = 0;x<(L/2)+1;x++){
Q[z][y][x]=Q[2*z][2*y][2*x];
//printf("Q[%d][%d][%d] %f\n",z,y,x,Q[z][y][x]);
}}}
/******************** Xi_ Methode **************************/
Start_Zufallszahlen(seed);
Gauss_Verteilung();
for(z = 0;z<(L/2)+1;z++){  
for(y = 0;y<(L/2)+1;y++){
for(x = 0;x<(L/2)+1;x++){
Energie[z][y][x]=sigma*x1[(((L/2)+1)*((L/2)+1))*z+((L/2)+1)*y+x]+Q[z][y][x];
//printf("Energie[%d][%d][%d] %f\n",z,y,x,Energie[z][y][x]);
}}}
/******************** mu_Bestimmung **************************/ 

/* Sorting array in binary tree format */
for(z = 0;z<nlin2;z++){  
for(y = 0;y<nlin2;y++){
for(x = 0;x<nlin2;x++){
data[nlin2*nlin2*z+nlin2*y+x]=Energie[z][y][x];
//printf("data[%d] %f\n",nlin2*nlin2*z+nlin2*y+x,data[nlin2*nlin2*z+nlin2*y+x]);
}}}

	for(i = 1; i < nlin2*nlin2*nlin2; i++) {
		v = i;
		do {
			root = (v - 1) / 2;
			if(data[root] < data[v]) {
				temp = data[root];
				data[root] = data[v];
				data[v] = temp;
			}
			v = root;
		}
		while(v != 0);
	}


	/* Sorting array from binary tree format to ascending order */
	for(j = (nlin2*nlin2*nlin2)-1; j > 0; j--) {
		temp = data[0];
		data[0] = data[j];
		data[j] = temp;
		root = 0;
		do {
			v = 2 * root + 1;
			if(data[v] < data[v+1] && v < (j-1))
				v++;
			if(data[root] < data[v] && v < j) {
				temp = data[root];
				data[root] = data[v];
				data[v] = temp;
			}
			root = v;
		}
		while(v < j);
	}
	//printf("After sort\n");
	for(i = 0; i < nlin2*nlin2*nlin2; i++)
		//printf("%f\n",data[i]);



mu= data[int( (nlin2-1)*(nlin2-1)*(nlin2-1)* CT)];
//printf("mu ist  %f\n",mu); 
/******************** Barriernetzwerk **************************/ 
for(z = 0;z <nlin2;z++){
for(y=0;y<nlin2;y++){
for(x=0;x<(nlin2-1) ;x++){
Bindung_X[z][y][x]=0.5*(fabs(Energie[z][y][x+1]-Energie[z][y][x])+fabs(Energie[z][y][x+1]-mu)+fabs(Energie[z][y][x]-mu));
//printf("Bindung_X[%d][%d][%d] ist %f\n",z, y,x,Bindung_X[z][y][x]); 
}}}
for(z = 0;z <nlin2;z++){
for(y=0;y<(nlin2-1);y++){
for(x=0;x<nlin2 ;x++){
Bindung_Y[z][y][x]=0.5*(fabs(Energie[z][y+1][x]-Energie[z][y][x])+fabs(Energie[z][y+1][x]-mu)+fabs(Energie[z][y][x]-mu));
//printf("Bindung_Y[%d][%d][%d] ist %f\n",z, y,x,Bindung_Y[z][y][x]); 
}}}
for(z = 0;z<(nlin2-1);z++){
for(y=0;y<(nlin2);y++){
for(x=0;x<(nlin2) ;x++){
Bindung_Z[z][y][x]=0.5*(fabs(Energie[z+1][y][x]-Energie[z][y][x])+fabs(Energie[z+1][y][x]-mu)+fabs(Energie[z][y][x]-mu));
//printf("Bindung_Z[%d][%d][%d] ist %f\n",z, y,x,Bindung_Z[z][y][x]); 
}}}
/***************************************************************************/
int Summe_1,Summe_2,Summe_3;
Summe_1=0;Summe_2=0;Summe_3=0;
for(z = 0;z<(nlin2);z++){
for(y=0;y<(nlin2);y++){
for(x=0;x<(nlin2-1) ;x++){
if(Bindung_X[z][y][x]<=U){
Energie[z][y][x]=Energie[z][y][x+1]=-1.0;
struc_help1[z][y][x]=1;}
//printf("struc_help1[%d][%d][%d] ist %d\n",z, y,x,struc_help1[z][y][x]); 
}}}
for(z = 0;z <(nlin2);z++){
for(y=0;y<(nlin2-1);y++){
for(x=0;x<(nlin2) ;x++){
if(Bindung_Y[z][y][x]<=U){
Energie[z][y][x]=Energie[z][y+1][x]=-1.0;
struc_help2[z][y][x]=1;}
//printf("struc_help2[%d][%d][%d] ist %d\n",z, y,x,struc_help2[z][y][x]); 
}}}
for(z = 0;z <(nlin2-1);z++){
for(y=0;y<(nlin2);y++){
for(x=0;x<(nlin2) ;x++){
if(Bindung_Z[z][y][x]<=U){
Energie[z][y][x]=Energie[z+1][y][x]=-1.0;
struc_help3[z][y][x]=1;}
//printf("struc_help3[%d][%d][%d] ist %d\n",z, y,x,struc_help3[z][y][x]); 
}}}

for(z = 0;z<(nlin2);z++){
for(y=0;y<(nlin2);y++){
for(x=0;x<(nlin2-1) ;x++){
Summe_1+=struc_help1[z][y][x];
}}}//printf("Summe_1 ist %d\n",Summe_1); 
for(z = 0;z <(nlin2);z++){
for(y=0;y<(nlin2-1);y++){
for(x=0;x<(nlin2) ;x++){
Summe_2+=struc_help2[z][y][x];
}}}//printf("Summe_2 ist %d\n",Summe_2);
for(z = 0;z <(nlin2-1);z++){
for(y=0;y<(nlin2);y++){
for(x=0;x<(nlin2) ;x++){
Summe_3+=struc_help3[z][y][x];
}}}//printf("Summe_3 ist %d\n",Summe_3);
/**************************************************************************/
for(z = 0;z <(nlin2);z++){
for(y=0;y<(nlin2);y++){
for(x=0;x<(nlin2) ;x++){
if(Energie[z][y][x]==-1.0){
Energie[z][y][x]=Energie[z][y][x];}
else{Energie[z][y][x]=0;}
//printf("struc[%d][%d][%d] ist %f\n",z, y,x,struc[z][y][x]);
}}}
/******************** Perkolation **************************/ 
calclabel();
for(z = 0;z <(nlin2);z++){
for(y = 0;y <(nlin2);y++){           
for(x = 0;x <(nlin2);x++){
label = cl[z][y][x];
if(label > 0){
label = proper(label);
cl[z][y][x] = label;
}
//printf("cl[%d][%d][%d] ist: %d\n",z,y,x,cl[z][y][x]);
}}}
/*******************************************************/  
Xmax=1;
for(z = 0;z <(nlin2);z++){
for(y = 0;y <(nlin2);y++){           
for(x = 0;x <(nlin2);x++){
if(cl[z][y][x]>Xmax){Xmax=cl[z][y][x];}}}}
for(l = 1;l <=Xmax ;l++){
h[l]=0;}
for(l = 1;l <=Xmax ;l++){
for(z = 0;z <(nlin2);z++){
for(y = 0;y <(nlin2);y++){           
for(x = 0;x <(nlin2);x++){
if(cl[z][y][x]==l){h[l]= h[l]+1;}}}}}
Hmax=0;
for(l = 1;l <=Xmax ;l++){
if(h[l]>Hmax){Hmax=h[l];}}
Hmax1=0;
for(l = 1;l <=Xmax ;l++){
if((h[l]>Hmax1)&&(h[l]!=Hmax)){Hmax1=h[l];}}
for(i = 1;i <=Xmax ;i++){
if(h[i]==Hmax)
ll=i;}
for(j = 1;j <=Xmax ;j++){
if(h[j]==Hmax1)
lll=j;}
/******************************************************************/  
          hhhh_x=0;
for(z = 0;z <(nlin2);z++){
for(y = 0;y <(nlin2);y++){           
for(x = 0;x <(nlin2);x++){
          if((cl[z][0][y]==ll)&&(cl[z][nlin2-1][x]==ll)){hhhh_x+=1;}
          }
          }
	  }
          if(hhhh_x!=0){/*printf("Der Label des unendlichen Clusters der %d-ten Konfiguration  ist links,rechts: %d\n",nc,ll);*/summe_x=1;}
          else if(hhhh_x==0){/*printf("Es gibt bei der %d-ten Konfiguration  keinen unendlichen Cluster links,rechts\n",nc);*/summe_x=0;}
        hhhh_y=0;
for(z = 0;z <(nlin2);z++){
for(y = 0;y <(nlin2);y++){           
for(x = 0;x <(nlin2);x++){
          if((cl[z][y][0]==ll)&&(cl[z][x][nlin2-1]==ll)){hhhh_y+=1;}
          }
          }
	  }
	  if(hhhh_y!=0){/*printf("Der Label des unendlichen Clusters der %d-ten Konfiguration  ist oben,unten: %d\n",nc,ll);*/summe_y=1;}
	  else if(hhhh_y==0){/*printf("Es gibt bei der %d-ten Konfiguration  keinen unendlichen Cluster oben,unten\n",nc);*/summe_y=0;}
	 hhhh_z=0;
for(z = 0;z <(nlin2);z++){
for(y = 0;y <(nlin2);y++){           
for(x = 0;x <(nlin2);x++){
          if((cl[0][y][x]==ll)&&(cl[y][nlin2-1][x]==ll)){hhhh_z+=1;}
          }
          }
	  }
	  if(hhhh_z!=0){/*printf("Der Label des unendlichen Clusters der %d-ten Konfiguration  ist vorne,hinter: %d\n",nc,ll);*/summe_z=1;}
	  else if(hhhh_z==0){/*printf("Es gibt bei der %d-ten Konfiguration  keinen unendlichen Cluster vorne,hinter\n",nc);*/summe_z=0;}

/*******************************************************/  
if((summe_x==1)||(summe_y==1)||(summe_z==1)){summe_c[nc]=1;}
else {summe_c[nc]=0;}

int Summe_4=0; int Summe_5=0; int Summe_6=0;
for(z = 0;z<(nlin2);z++){
for(y=0;y<(nlin2);y++){
for(x=0;x<(nlin2-1) ;x++){
if((struc_help1[z][y][x]==1)&&(hhhh_x!=0)){if((cl[z][y][x]==ll)&&(cl[z][y][x+1]==ll)){Summe_4+=1;}}
}}}//printf("Summe_4 ist %d\n",Summe_4); 
for(z = 0;z <(nlin2);z++){
for(y=0;y<(nlin2-1);y++){
for(x=0;x<(nlin2) ;x++){
if((struc_help2[z][y][x]==1)&&(hhhh_y!=0)){if((cl[z][y][x]==ll)&&(cl[z][y+1][x]==ll)){Summe_5+=1;}}
}}}//printf("Summe_5 ist %d\n",Summe_5); 
for(z = 0;z <(nlin2-1);z++){
for(y=0;y<(nlin2);y++){
for(x=0;x<(nlin2) ;x++){
if((struc_help3[z][y][x]==1)&&(hhhh_z!=0)){if((cl[z+1][y][x]==ll)){Summe_6+=1;}}
}}}//printf("Summe_6 ist %d\n",Summe_6); 



P_inf[nc]=(double)(Summe_4+Summe_5+Summe_6)/(Summe_1+Summe_2+Summe_3);
//printf(" P_inf bei %d Konfigurationen ist %f\n",nc, P_inf[nc]); 
}     /*  Ende der Konfigurationschleife  */

double P=0;
summe_cl=0;
for(nc=0;nc<Nc;nc++){  
summe_cl+=summe_c[nc];
P+=P_inf[nc];
} 
printf(" die Anzahl der unendlichen Cluster bei %d Konfigurationen ist %d\n",Nc, summe_cl); 
printf(" P bei %d Konfigurationen ist %f\n",Nc, (double)(P/Nc)); 
 


return 0;
}

/************************************************************************************/
void Distribution_Unites()
{

i=0;
while(i<int(C_P1*((L/2)*(L/2)*(L/2)))){
Kirkpatrick; rnd1 = mz[iz]*norm;Kirkpatrick; rnd2 = mz[iz]*norm;Kirkpatrick; rnd3 = mz[iz]*norm;
jG1=(int)(((L/2))*rnd1);jG2=(int)(((L/2))*rnd2);jG3=(int)(((L/2))*rnd3);
if(P_1[2*jG1+1][2*jG2+1][2*jG3+1]==0){      //printf("der %d-te zufaellig gewaehlte Punkt  ist: (%d,%d,%d)\n",i,2*jG1+1,2*jG2+1,2*jG3+1);
P_1[2*jG1+1][2*jG2+1][2*jG3+1]=1; 
i++;}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
i=0;
while(i<int(C_P2*((L/2)*(L/2)*(L/2)))){
Kirkpatrick; rnd1 = mz[iz]*norm;Kirkpatrick; rnd2 = mz[iz]*norm;Kirkpatrick; rnd3 = mz[iz]*norm;
jG1=(int)(((L/2))*rnd1);jG2=(int)(((L/2))*rnd2);jG3=(int)(((L/2))*rnd3);
if((P_1[2*jG1+1][2*jG2+1][2*jG3+1]==0)&&(P_2[2*jG1+1][2*jG2+1][2*jG3+1]==0)){ //printf("der %d-te zufaellig gewaehlte Punkt  ist: (%d,%d,%d)\n",i,2*jG1+1,2*jG2+1,2*jG3+1);
P_2[2*jG1+1][2*jG2+1][2*jG3+1]=1; 
i++;}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
i=0;
while(i<int(C_P3*((L/2)*(L/2)*(L/2)))){
Kirkpatrick; rnd1 = mz[iz]*norm;Kirkpatrick; rnd2 = mz[iz]*norm;Kirkpatrick; rnd3 = mz[iz]*norm;
jG1=(int)(((L/2))*rnd1);jG2=(int)(((L/2))*rnd2);jG3=(int)(((L/2))*rnd3);
if((P_1[2*jG1+1][2*jG2+1][2*jG3+1]==0)&&(P_2[2*jG1+1][2*jG2+1][2*jG3+1]==0)&&(P_3[2*jG1+1][2*jG2+1][2*jG3+1]==0)){
//printf("der %d-te zufaellig gewaehlte Punkt  ist: (%d,%d,%d)\n",i,2*jG1+1,2*jG2+1,2*jG3+1);
P_3[2*jG1+1][2*jG2+1][2*jG3+1]=1; 
i++;}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
i=0;
while(i<int(C_Te1*((L/2)*(L/2)*(L/2)))){
Kirkpatrick; rnd1 = mz[iz]*norm;Kirkpatrick; rnd2 = mz[iz]*norm;Kirkpatrick; rnd3 = mz[iz]*norm;
jG1=(int)(((L/2))*rnd1);jG2=(int)(((L/2))*rnd2);jG3=(int)(((L/2))*rnd3);
if((Te_1[2*jG1+1][2*jG2+1][2*jG3+1]==0)&&(P_1[2*jG1+1][2*jG2+1][2*jG3+1]==0)&&(P_2[2*jG1+1][2*jG2+1][2*jG3+1]==0)&&(P_3[2*jG1+1][2*jG2+1][2*jG3+1]==0)){      
//printf("der %d-te zufaellig gewaehlte Punkt  ist: (%d,%d,%d)\n",i,2*jG1+1,2*jG2+1,2*jG3+1);
Te_1[2*jG1+1][2*jG2+1][2*jG3+1]=1; 
i++;}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
i=0;
while(i<int(C_Te4*((L/2)*(L/2)*(L/2)))){
Kirkpatrick; rnd1 = mz[iz]*norm;Kirkpatrick; rnd2 = mz[iz]*norm;Kirkpatrick; rnd3 = mz[iz]*norm;
jG1=(int)(((L/2))*rnd1);jG2=(int)(((L/2))*rnd2);jG3=(int)(((L/2))*rnd3);
if((Te_4[2*jG1+1][2*jG2+1][2*jG3+1]==0)&&(Te_1[2*jG1+1][2*jG2+1][2*jG3+1]==0)&&(P_1[2*jG1+1][2*jG2+1][2*jG3+1]==0)&&(P_2[2*jG1+1][2*jG2+1][2*jG3+1]==0)&&(P_3[2*jG1+1][2*jG2+1][2*jG3+1]==0)){     
 //printf("der %d-te zufaellig gewaehlte Punkt  ist: (%d,%d,%d)\n",i,2*jG1+1,2*jG2+1,2*jG3+1);
Te_4[2*jG1+1][2*jG2+1][2*jG3+1]=1; 
i++;}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}
/************************************************************************************/
void Distribution_Charges()
{

for(z = 0;z<(L/2);z++){  
for(y = 0;y<(L/2);y++){
for(x = 0;x<(L/2);x++){
/*********************************/
if(P_1[2*z+1][2*y+1][2*x+1]==1){
i=0;
while(i<1){/*1*/
Kirkpatrick; rnd1 = mz[iz]*norm;rnd4=int(8*rnd1);
Kirkpatrick; rnd1 = mz[iz]*norm;rnd5=int(8*rnd1);
if(rnd4!=rnd5){/*2*/
Kirkpatrick; rnd1 = mz[iz]*norm;rnd6=int(8*rnd1);
if((rnd6!=rnd5)&(rnd6!=rnd4)){/*3*/
/*printf("rnd4 bei der Punkt(%d,%d,%d) %d\n",2*z+1,2*y+1,2*x+1,rnd4);
printf("rnd5 bei der Punkt(%d,%d,%d) %d\n",2*z+1,2*y+1,2*x+1,rnd5);
printf("rnd6 bei der Punkt(%d,%d,%d) %d\n",2*z+1,2*y+1,2*x+1,rnd6);*/
if((rnd4==0)||(rnd5==0)||(rnd6==0)){Q[2*z][2*y][2*x]+=0.67;}
if((rnd4==1)||(rnd5==1)||(rnd6==1)){Q[2*z+2][2*y][2*x]+=0.67;}
if((rnd4==2)||(rnd5==2)||(rnd6==2)){Q[2*z+2][2*y+2][2*x]+=0.67;}
if((rnd4==3)||(rnd5==3)||(rnd6==3)){Q[2*z][2*y+2][2*x]+=0.67;}
if((rnd4==4)||(rnd5==4)||(rnd6==4)){Q[2*z][2*y][2*x+2]+=0.67;}
if((rnd4==5)||(rnd5==5)||(rnd6==5)){Q[2*z+2][2*y][2*x+2]+=0.67;}
if((rnd4==6)||(rnd5==6)||(rnd6==6)){Q[2*z+2][2*y+2][2*x+2]+=0.67;}
if((rnd4==7)||(rnd5==7)||(rnd6==7)){Q[2*z][2*y+2][2*x+2]+=0.67;}
i++;
}/*3*/}/*2*/}/*1*/

}
if((P_2[2*z+1][2*y+1][2*x+1]==1)){
i=0;
while(i<1){/*1*/
Kirkpatrick; rnd1 = mz[iz]*norm;
rnd4=int(8*rnd1);
Kirkpatrick; rnd1 = mz[iz]*norm;rnd5=int(8*rnd1);
if(rnd4!=rnd5){/*2*/
if((rnd4==0)||(rnd5==0)){Q[2*z][2*y][2*x]+=0.5;}
if((rnd4==1)||(rnd5==1)){Q[2*z+2][2*y][2*x]+=0.5;}
if((rnd4==2)||(rnd5==2)){Q[2*z+2][2*y+2][2*x]+=0.5;}
if((rnd4==3)||(rnd5==3)){Q[2*z][2*y+2][2*x]+=0.5;}
if((rnd4==4)||(rnd5==4)){Q[2*z][2*y][2*x+2]+=0.5;}
if((rnd4==5)||(rnd5==5)){Q[2*z+2][2*y][2*x+2]+=0.5;}
if((rnd4==6)||(rnd5==6)){Q[2*z+2][2*y+2][2*x+2]+=0.5;}
if((rnd4==7)||(rnd5==7)){Q[2*z][2*y+2][2*x+2]+=0.5;}
i++;
}/*2*/}/*1*/
}
/*if((Te_1[2*z+1][2*y+1][2*x+1]==1)){
i=0;
while(i<1){
Kirkpatrick; rnd1 = mz[iz]*norm;
rnd4=int(8*rnd1);

//printf("rnd4 bei der Punkt(%d,%d,%d) %d\n",2*z+1,2*y+1,2*x+1,rnd4);
//printf("rnd5 bei der Punkt(%d,%d,%d) %d\n",2*z+1,2*y+1,2*x+1,rnd5);

if((rnd4==0)){Q[2*z][2*y][2*x]+=1.0;}
if((rnd4==1)){Q[2*z+2][2*y][2*x]+=1.0;}
if((rnd4==2)){Q[2*z+2][2*y+2][2*x]+=1.0;}
if((rnd4==3)){Q[2*z][2*y+2][2*x]+=1.0;}
if((rnd4==4)){Q[2*z][2*y][2*x+2]+=1.0;}
if((rnd4==5)){Q[2*z+2][2*y][2*x+2]+=1.0;}
if((rnd4==6)){Q[2*z+2][2*y+2][2*x+2]+=1.0;}
if((rnd4==7)){Q[2*z][2*y+2][2*x+2]+=1.0;}
i++;
}}*/

if((Te_1[2*z+1][2*y+1][2*x+1]==1)){
i=0;
while(i<1){
Kirkpatrick; rnd1 = mz[iz]*norm;
rnd4=int(8*rnd1);
Kirkpatrick; rnd1 = mz[iz]*norm;rnd5=int(8*rnd1);
if(rnd4!=rnd5){
//printf("rnd4 bei der Punkt(%d,%d,%d) %d\n",2*z+1,2*y+1,2*x+1,rnd4);
//printf("rnd5 bei der Punkt(%d,%d,%d) %d\n",2*z+1,2*y+1,2*x+1,rnd5);

if((rnd4==0)||(rnd5==0)){Q[2*z][2*y][2*x]+=0.5;}
if((rnd4==1)||(rnd5==1)){Q[2*z+2][2*y][2*x]+=0.5;}
if((rnd4==2)||(rnd5==2)){Q[2*z+2][2*y+2][2*x]+=0.5;}
if((rnd4==3)||(rnd5==3)){Q[2*z][2*y+2][2*x]+=0.5;}
if((rnd4==4)||(rnd5==4)){Q[2*z][2*y][2*x+2]+=0.5;}
if((rnd4==5)||(rnd5==5)){Q[2*z+2][2*y][2*x+2]+=0.5;}
if((rnd4==6)||(rnd5==6)){Q[2*z+2][2*y+2][2*x+2]+=0.5;}
if((rnd4==7)||(rnd5==7)){Q[2*z][2*y+2][2*x+2]+=0.5;}
i++;
}}}

/*********************************/
}}}

}
/**********************************************************************/
void Distribution_Concentration()
{
if(X==0.0){C_P1=0.0;                         C_P2=0.49500998004;                 C_P3=0.50499001996;           C_Te1=0.0;                   C_Te4=0;}
if(X==0.1){C_P1=0.0;                         C_P2=0.46534653465;                 C_P3=0.42574257425;           C_Te1=0.02970297029;         C_Te4=0.07920792079;}
if(X==0.2){C_P1=0.0;                         C_P2=0.42126379137;                 C_P3=0.38114343029;           C_Te1=0.08726178535;         C_Te4=0.11033099297;}
if(X==0.3){C_P1=0.0;                         C_P2=0.36;                          C_P3=0.34;                    C_Te1=0.14;                  C_Te4=0.16;}
if(X==0.4){C_P1=0.0;                         C_P2=0.33830845771;                 C_P3=0.26368159204;           C_Te1=0.1592039801;          C_Te4=0.23880597014;}
if(X==0.5){C_P1=0.0;                         C_P2=0.325;                         C_P3=0.17;                    C_Te1=0.17;                  C_Te4=0.335;}
if(X==0.6){C_P1=0.01980198019;               C_P2=0.28712871287;                 C_P3=0.09900990099;           C_Te1=0.18811881188;         C_Te4=0.40594059405;}
if(X==0.7){C_P1=0.0294117647;                C_P2=0.22058823529;                 C_P3=0.06372549019;           C_Te1=0.24705882352;         C_Te4=0.43921568627;}
if(X==0.8){C_P1=0.05489569817;               C_P2=0.09981036031;                 C_P3=0.04980536979;           C_Te1=0.29643677013;         C_Te4=0.49905180157;}
if(X==0.9){C_P1=0.05870841487;               C_P2=0.03913894324;                 C_P3=0.01467710371;           C_Te1=0.33953033268;         C_Te4=0.54794520547;}
if(X==1.0){C_P1=0.0;                         C_P2=0.0;                           C_P3=0.0;                     C_Te1=0.5;                   C_Te4=0.5;}
}
/**********************************************************************/
void Initialization()
{
for(z = 0;z<(L/2);z++){  
for(y = 0;y<(L/2);y++){
for(x = 0;x<(L/2);x++){ 
P_1[2*z+1][2*y+1][2*x+1]=0.0;    P_2[2*z+1][2*y+1][2*x+1]=0.0;      P_3[2*z+1][2*y+1][2*x+1]=0.0;    
Te_1[2*z+1][2*y+1][2*x+1]=0.0;   Te_4[2*z+1][2*y+1][2*x+1]=0.0; //printf("Te_4[%d][%d][%d] ist %d\n",2*z+1, 2*y+1,2*x+1,Te_4[2*z+1][2*y+1][2*x+1]);   
}}}
for(z = 0;z<(L/2)+1;z++){  
for(y = 0;y<(L/2)+1;y++){
for(x = 0;x<(L/2)+1;x++){
Q[2*z][2*y][2*x]=0;//printf("Q[%d][%d][%d] ist %f\n",2*z, 2*y,2*x,Q[2*z][2*y][2*x]);  
}}}
for(z = 0;z<(nlin2);z++){
for(y=0;y<(nlin2);y++){
for(x=0;x<(nlin2-1) ;x++){
struc_help1[z][y][x]=0.0;
}}}
for(z = 0;z <(nlin2);z++){
for(y=0;y<(nlin2-1);y++){
for(x=0;x<(nlin2) ;x++){
struc_help2[z][y][x]=0.0;
}}}
for(z = 0;z <(nlin2-1);z++){
for(y=0;y<(nlin2);y++){
for(x=0;x<(nlin2) ;x++){
struc_help3[z][y][x]=0.0;
}}}

for(z = 0;z<nlin2;z++){  
for(y = 0;y<nlin2;y++){
for(x = 0;x<nlin2;x++){ 
Energie[z][y][x]=0.0;
}}}
}
/**********************************************************************/
void Start_Zufallszahlen(int seed)		// Kirkpatrick-Stoll-ZZgenerator
{ 
	Jitoz = 0;
	Jdimax = 1. / Jiadd;
   	lm = 2 * seed + 1;	
   	for (i = 0; i < 250; i++)	{ 
		lm *= Jmult;
     		if (lm < 0) 
			lm += Jiadd + 1;
		Jmz[i] = lm;		    		
	}
}  
/* end of Start_Zufallszahlen() */
/*********************************************************************************/					
void Gauss_Verteilung()
{
int z,y,x;
double y3[L*L*L],v1, v2, w,ave_x, var_x;
	ave_x = 0.0;					// neue Initialisierungen
	v1 =	0.0;
	v2 =	0.0;
	w =	0.0;
	lm = 	0;					// Groesse aus Start_Zufallszahlen !

	for(i = 0; i <(((L/2)+1))*(((L/2)+1))*(((L/2)+1)); i++)	{
		x1[i] = y3[i] = 0.0;
	}	
			
	for(i = 0; i <(((L/2)+1))*(((L/2)+1))*(((L/2)+1)); i++)	{			// Verbess. der Gauss-Vert. durch ZGS.
		for(j = 0; j < 9; j++)	{		// ** (siehe Ende der Schleife)
			y3[j] = 0.0;
			do	{
				Jitoz = (Jitoz + 1) % 250;
				Jmz[Jitoz] ^= Jmz[(Jitoz + 103) % 250];	// fuer jede Nummer
				v1 = 2.0 * Jmz[Jitoz] * Jdimax - 1.0;	// gleichvert.Var.1

	   			Jitoz = (Jitoz + 1) % 250;
				Jmz[Jitoz] ^= Jmz[(Jitoz + 103) % 250];	// fuer jede Nummer
				v2 = 2.0 * Jmz[Jitoz] * Jdimax - 1.0;	// gleichvert.Var.1

				w = v1*v1 + v2*v2;			
			}
			while(w >= 1.0);		// Varianzabfrage
			w = sqrt((-2.0 * log(w)/w));
			y3[j] = v1 * w;			// Gauss-verteilt mit Var.1
			x1[i] += y3[j];
		}
		x1[i] = x1[i]/3.0;			// gehoert zu **
		//printf("%d\t %f\n", i, (x1[i]));
		ave_x += x1[i];				// Summe zur Mittelwertbildung
	}
	ave_x /= (double)((((L/2)+1))*(((L/2)+1))*(((L/2)+1)));
	//printf("x-Mittel (unkorreliert)	= %f\n", ave_x);
	ave_x = 0.0;


}
/*********************************************************************************/

