/**********************************************************************/
/******


Dieses Program wurde zur analytischen Berechnung 
der Aktivierungsenergie einer ungeordneten Energielandschaft
mit gleichverteilter Energien mit der Hilfe der Perkolationstheorie erstellt.


********/
/**********************************************************************/




#include<stdio.h>
#include <stdlib.h> 
#include <string.h> 
#include <math.h> 

void labelmin_sw(int z, int y, int x, int south, int west);
void labelmin_dw(int z, int y, int x, int down, int west);
void labelmin_ds(int z, int y, int x, int down, int south);
void neighbours_dsw(int z,int y,int x,int down,int south,int west);
void labelmin_dsw(int z, int y, int x, int down, int south, int west);
int intmax(int valuea,int valueb);
int intmin(int valuea,int valueb);
int proper( int label );
int findmin(int a, int b, int c );
void printlabel();
int newcluster(int ncluster, int z, int y, int x);
void initlabel();
void calclabel();
void neighbours_sw(int z, int y, int x, int south, int west);
void neighbours_ds(int z, int y, int x, int south, int west);
void neighbours_dw(int z, int y, int x, int south, int west);

#define nlin 30
#define K 1
#define xi_c 0.515
#define c1 0.6



int lm;
double Jdimax;
int Jmult = 16807, Jiadd = 2147483647,Jmz[250],Jitoz;
double x1[nlin*nlin*nlin];
void Start_Zufallszahlen(int seed);		                        
void Gauss_Verteilung();
/************************/

int label,seed,iz=1,mz[250];
double norm,jzmax=2147483647;
int i,j,k,x,y,z,l,summe[nlin*nlin],summe2[nlin*nlin],summe3[nlin*nlin],Hmax,lly,Hmax1,h_k_x,h_k_y,h_k_z,h_kk[nlin*nlin],hhhh,hhhh_x,hhhh_y,hhhh_z,h[nlin*nlin];
int pp;

double rnd1;
double rnd,p1[nlin*nlin],p2[nlin*nlin],p[nlin*nlin],lattice[nlin][nlin][nlin];
int summe_hh_k[nlin*nlin],hh,hh_k[1000][1000],hhh[nlin*nlin];
int summe1,summe4[nlin*nlin],h_x[nlin*nlin],h_y[nlin*nlin],ll,lll,J,h_max,hh_max,hhh_max,hhhh_max,summe_c[K],summe_cl; 
int Xmax;
//Global parameter von label
int cl[nlin][nlin][nlin];
double struc[nlin][nlin][nlin],struc3[nlin][nlin][nlin],struc1[nlin][nlin][nlin],struc2[nlin][nlin][nlin],struc4[nlin][nlin][nlin];
//--------------------------------
//Global parameter von hilfreichen Gittern
int struc_help1[nlin][nlin][nlin+1],struc_help2[nlin][nlin+1][nlin],struc_help3[nlin+1][nlin][nlin];
int np[500000];
//--------------------------------
void rndNum(int seed)  //Kirkpatrick Stall Generator1
{
int jz,a0=16807;
norm=1.0/jzmax;
jz=2*seed+1;
for(i=0;i < 250;i++){
jz *= a0;
if(jz < 0)
jz += jzmax +1;
mz[i] = jz;}
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void Struktur()  //Kirkpatrick Stall Generator1
{
Start_Zufallszahlen(seed);
Gauss_Verteilung();
for(z = 0;z <(nlin);z++){
for(y = 0;y <(nlin);y++){           
for(x = 0;x <(nlin);x++){
struc[z][y][x]=lattice[z][y][x];//printf("struc[%d][%d][%d] ist %f\n",z,y,x,struc[z][y][x]);
}}}
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void calclabel()
{
 int x,y,z;
  int ncluster = 0; 
  int down=0,west=0,south=0;

for(z = 0;z <(nlin);z++){
for(y = 0;y <(nlin);y++){           
for(x = 0;x <(nlin);x++){
           cl[z][y][x] = 0;
     }}}

x = 0;
if( struc[0][0][0]<0 )
ncluster = newcluster(ncluster,0, 0, 0);


for(z = 1; z <(nlin);z++){
       if( struc[z][0][x]<0 ){
            west = z -1;
            if((struc[west][0][x]<0)&&(struc_help3[z-1][0][x]==1))
               cl[z][0][x] = cl[west][0][x]; 
            else 
               ncluster = newcluster( ncluster,z,  0, x);
       }
  }

  for(y = 1; y <(nlin);y++){
       if(struc[0][y][x]<0){
          south = y - 1;
          if((struc[0][south][x]<0)&&(struc_help2[0][y-1][x]==1))
             cl[0][y][x] = cl[0][south][x];
          else
             ncluster = newcluster( ncluster,0,y , x);
       }
       for(z = 1; z<(nlin);z++){
          if(struc[z][y][x]<0){
             south =y - 1;
             west = z - 1;
                           if((struc_help3[z-1][y][x]==0)&&(struc_help2[z][y-1][x]==0))
                                             ncluster = newcluster(ncluster,z, y, x);

                            if((struc_help3[z-1][y][x]==1)&&(struc_help2[z][y-1][x]==0))
                                          cl[z][y][x] = cl[west][y][x];

                                                                                              
                               if((struc_help3[z-1][y][x]==0)&&(struc_help2[z][y-1][x]==1))

                                 cl[z][y][x] =cl[z][south][x];


                               if((struc_help3[z-1][y][x]==1)&&(struc_help2[z][y-1][x]==1))
                                          neighbours_sw(z, y, x, south, west);
          }
       }
  }



 for(x = 1; x <(nlin); x++){
      if(struc[0][0][x] < 0){
         down = x - 1;
         if((struc[0][0][down] < 0)&(struc_help1[0][0][x-1]==1))
            cl[0][0][x] = cl[0][0][down];
         
         else
            ncluster = newcluster(ncluster,0, 0, x);
         
      }


      for(z = 1; z <(nlin);z++){
          if(struc[z][0][x] < 0){
             down = x - 1;
             west = z - 1;
                           if((struc_help3[z-1][0][x]==0)&&(struc_help1[z][0][x-1]==0))
                                             ncluster = newcluster(ncluster,z, 0, x);

                            if((struc_help3[z-1][0][x]==1)&&(struc_help1[z][0][x-1]==0))
                                          cl[z][0][x] = cl[west][0][x];

                                                                                              
                               if((struc_help3[z-1][0][x]==0)&&(struc_help1[z][0][x-1]==1))

                                 cl[z][0][x] =cl[z][0][down];


                               if((struc_help3[z-1][0][x]==1)&&(struc_help1[z][0][x-1]==1))
                                          neighbours_dw(z, 0, x, down, west);
          }
      }

      for(y = 1;y <(nlin);y++){
         if(struc[0][y][x] < 0){
             down  =  x - 1;
             south = y - 1;
                                if((struc_help1[0][y][x-1]==0)&&(struc_help2[0][y-1][x]==0))
                                             ncluster = newcluster(ncluster,0, y, x);

                                if((struc_help1[0][y][x-1]==1)&&(struc_help2[0][y-1][x]==0))
                                          cl[0][y][x] = cl[0][y][down];

                                                                                              
                               if((struc_help1[0][y][x-1]==0)&&(struc_help2[0][y-1][x]==1))

                                 cl[0][y][x] =cl[0][south][x];


                               if((struc_help1[0][y][x-1]==1)&&(struc_help2[0][y-1][x]==1))
                                neighbours_ds(0, y, x, down, south);
             
         }
         for(z = 1;z <(nlin);z++){
            if(struc[z][y][x] < 0){
               down = x-1;
               south = y-1;
               west = z-1;

if(((struc_help3[z-1][y][x]==0)&&(struc_help2[z][y-1][x]==0))&&(struc_help1[z][y][x-1]==0))
ncluster = newcluster(ncluster,z,y,x);

else{

if((struc_help3[z-1][y][x]==1)&&(struc_help2[z][y-1][x]==0)&&(struc_help1[z][y][x-1]==0)){
cl[z][y][x] = cl[west][y][x];}       


if((struc_help3[z-1][y][x]==0)&&(struc_help2[z][y-1][x]==1)&&(struc_help1[z][y][x-1]==0)){               
cl[z][y][x] =cl[z][south][x];}


if(((struc_help3[z-1][y][x]==0)&&(struc_help2[z][y-1][x]==0))&&(struc_help1[z][y][x-1]==1)){                                  
cl[z][y][x] =cl[z][y][down];}


if((struc_help3[z-1][y][x]==1)&&(struc_help2[z][y-1][x]==1)&&(struc_help1[z][y][x-1]==0)){
neighbours_sw(z, y, x, south, west);}


if((struc_help3[z-1][y][x]==1)&&(struc_help2[z][y-1][x]==0)&&(struc_help1[z][y][x-1]==1)){                                   
neighbours_dw(z, y, x, down, west);}


if(((struc_help3[z-1][y][x]==0)&&(struc_help2[z][y-1][x]==1))&&(struc_help1[z][y][x-1]==1)){
neighbours_ds(z, y, x, down, south);}


if(((struc_help3[z-1][y][x]==1)&&(struc_help2[z][y-1][x]==1))&&(struc_help1[z][y][x-1]==1)){                                   
neighbours_dsw(z, y, x, down, south, west);}
}

               
            }
         }
      }
      
  }








}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int newcluster(int ncluster, int z, int y, int x)  // fuer neue cluster
{
   ncluster += 1;

   cl[z][y][x] = ncluster;

   np[ncluster-1] = 0;

   return ncluster;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void neighbours_sw(int z, int y, int x, int south, int west)  // nachbarn sw
{

   if( struc[west][y][x] *struc[z][south][x] > 0 ){
         labelmin_sw( z,y, x, south, west);
         return;
   }
   else if( cl[z][south][x] > 0  ){
       cl[z][y][x] = cl[z][south][x];
       return;
   }
   else
       cl[z][y][x] = cl[west][y][x];

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void neighbours_dw(int z, int y, int x, int down, int west) // nachbarn dw
{

   if( struc[z][y][down] * struc[west][y][x] > 0 ){
         labelmin_dw( z, y, x, down, west);
         return;
   }
   else if( cl[z][y][down] > 0  ){
       cl[z][y][x] = cl[z][y][down];
       return;
   }
   else
       cl[z][y][x] = cl[west][y][x];

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void neighbours_ds(int z, int y, int x, int down, int south)  // nachbarn ds
{

   if( struc[z][y][down] * struc[z][south][x] > 0 ){
         labelmin_ds( z, y, x, down, south);
         return;
   }
   else if( cl[z][y][down] > 0  ){
       cl[z][y][x]=cl[z][y][down];
       return;
   }
   else
       cl[z][y][x] = cl[z][south][x];

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void labelmin_sw(int z, int y, int x, int south, int west) // minimum aus zwei label sw
{
   int label1=0, label2=0;
   int lmax=0 ,lmin=0;


   if( cl[west][y][x] == cl[z][south][x] )
       cl[z][y][x] = cl[west][y][x];
   else
   {
       label1 = cl[west][y][x];
       label2 = cl[z][south][x];

       label1 = proper(label1);
       label2 = proper(label2);

       lmax = intmax( label1,label2 );
       lmin = intmin( label1,label2 );

       cl[z][y][x] = lmin;

       if(lmax != lmin)
          np[lmax-1] = lmin;
   }

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void labelmin_dw(int z, int y, int x, int down, int west) // minimum aus zwei label dw
{
   int label1=0, label2=0;
   int lmax=0 ,lmin=0;

   if( cl[z][y][down] == cl[west][y][x] )
       cl[z][y][x] = cl[west][y][x];
   else
   {
       label1 = cl[z][y][down];
       label2 = cl[west][y][x];

       label1 = proper(label1);
       label2 = proper(label2);

       lmax = intmax( label1,label2 );
       lmin = intmin( label1,label2 );

       cl[z][y][x] = lmin;

       if(lmax != lmin)
          np[lmax-1] = lmin;
   }

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void labelmin_ds(int z, int y, int x, int down, int south) // minimum aus zwei label ds
{
   int label1=0, label2=0;
   int lmax=0 ,lmin=0;

   if( cl[z][y][down] == cl[z][south][x] )
       cl[z][y][x] = cl[z][south][x];
   else
   {
       label1 = cl[z][y][down];
       label2 = cl[z][south][x];

       label1 = proper(label1);
       label2 = proper(label2);

       lmax = intmax( label1,label2 );
       lmin = intmin( label1,label2 );

       cl[z][y][x] = lmin;

       if(lmax != lmin)
          np[lmax-1] = lmin;
   }

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void neighbours_dsw(int z, int y ,int x ,int down ,int south ,int west)  // ermittelt nachbarn dsw
{
   if(struc[z][y][down] * struc[z][south][x] * struc[west][y][x] > 0){
         labelmin_dsw( z, y, x, down, south, west);
         return;
   }
   else if(struc[west][y][x] * struc[z][south][x] > 0){
        labelmin_sw(z, y, x, south, west);
         return;
   }
   else if(struc[z][y][down] * struc[west][y][x] > 0){
         labelmin_dw(z, y, x, down, west);
         return;
   }
   else if(struc[z][y][down] * struc[z][south][x] > 0){
         labelmin_ds(z, y, x, down, south);
         return;
   }
   else if(cl[z][y][down] > 0){
       cl[z][y][x] = cl[z][y][down];
       return;
   }
   else if(cl[z][south][x] > 0 ){
       cl[z][y][x] = cl[z][south][x];
       return;
   }
   else{
       cl[z][y][x] = cl[west][y][x];
   }
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void labelmin_dsw(int z, int y, int x, int down, int south, int west) // sucht minimum aus drei label d,s,w
{
   int label1=0, label2=0, label3=0;
   int lmin=0;


   if((cl[z][y][down] == cl[z][south][x]) && (cl[z][y][down] == cl[west][y][x]) )
       cl[z][y][x] = cl[z][south][x];
   else
   {
       label1 = cl[z][y][down];
       label2 = cl[z][south][x];
       label3 = cl[west][y][x];

       label1 = proper(label1);
       label2 = proper(label2);
       label3 = proper(label3);

       lmin = findmin(label1, label2, label3);

       cl[z][y][x] = lmin;

       if(label1 != lmin)
          np[label1-1] = lmin;
       if(label2 != lmin)
          np[label2-1] = lmin;
       if(label3 != lmin)
          np[label3-1] = lmin;

   }

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int proper(int label)  // sucht proper label
{

   while( np[label -1] != 0 ){
      label = np[label -1];
  }

  return label;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int intmax(int valuea,int valueb)
{
    if(valuea < valueb)
       return valueb;
    else 
       return valuea;
}
//------------------------------------------------------
int intmin(int valuea,int valueb)
{
    if(valuea < valueb)
       return valuea;
    else 
       return valueb;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int findmin(int a, int b, int c )  //findet minimum aus a,b,c
{
   int min;

   if((a <= b && b <= c) || (a <= c && c <= b))
     min = a;
   else if((b <= a && a <= c) || (b <= c && c <= a))
     min = b;
   else 
     min = c;

   return min;

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int main() //hauptfunktion
{
double mu;
seed=372067;
rndNum(seed);
for(i=0;i<500000; i++){
np[i]=0;
}
Struktur();
mu=0.253347 ;
for(z = 0;z <(nlin);z++){
for(y=0;y<(nlin);y++){
for(x=0;x<(nlin-1) ;x++){
struc1[z][y][x]=0.5*(fabs(struc[z][y][x+1]-struc[z][y][x])+fabs(struc[z][y][x+1]-mu)+fabs(mu-struc[z][y][x]));
//printf("struc1[%d][%d][%d] ist %f\n",z, y,x,struc1[z][y][x]); 
}}}
for(z = 0;z <(nlin);z++){
for(y=0;y<(nlin-1);y++){
for(x=0;x<(nlin) ;x++){
struc2[z][y][x]=0.5*(fabs(struc[z][y+1][x]-struc[z][y][x])+fabs(struc[z][y+1][x]-mu)+fabs(mu-struc[z][y][x]));
//printf("struc2[%d][%d][%d] ist %f\n",z, y,x,struc2[z][y][x]); 
}}}
for(z = 0;z<(nlin-1);z++){
for(y=0;y<(nlin);y++){
for(x=0;x<(nlin) ;x++){
struc4[z][y][x]=0.5*(fabs(struc[z+1][y][x]-struc[z][y][x])+fabs(mu-struc[z+1][y][x])+fabs(mu-struc[z][y][x]));
//printf("struc4[%d][%d][%d] ist %f\n",z, y,x,struc4[z][y][x]); 
}}}
//****************************************************************************
for(z = 0;z<(nlin);z++){
for(y=0;y<(nlin);y++){
for(x=0;x<(nlin-1) ;x++){
if(struc1[z][y][x]<xi_c){
struc[z][y][x]=struc[z][y][x+1]=-1.0;
struc_help1[z][y][x]=1;}
//printf("struc_help1[%d][%d][%d] ist %d\n",z, y,x,struc_help1[z][y][x]); 
}}}
for(z = 0;z <(nlin);z++){
for(y=0;y<(nlin-1);y++){
for(x=0;x<(nlin) ;x++){
if(struc2[z][y][x]<xi_c){
struc[z][y][x]=struc[z][y+1][x]=-1.0;
struc_help2[z][y][x]=1;}
//printf("struc_help2[%d][%d][%d] ist %d\n",z, y,x,struc_help2[z][y][x]); 
}}}
for(z = 0;z <(nlin-1);z++){
for(y=0;y<(nlin);y++){
for(x=0;x<(nlin) ;x++){
if(struc4[z][y][x]<xi_c){
struc[z][y][x]=struc[z+1][y][x]=-1.0;
struc_help3[z][y][x]=1;}
//printf("struc_help3[%d][%d][%d] ist %d\n",z, y,x,struc_help3[z][y][x]); 
}}}
//****************************************************************************
for(z = 0;z <(nlin);z++){
for(y=0;y<(nlin);y++){
for(x=0;x<(nlin) ;x++){
if(struc[z][y][x]==-1.0){
struc[z][y][x]=struc[z][y][x];}
else{struc[z][y][x]=0;}
//printf("struc[%d][%d][%d] ist %f\n",z, y,x,struc[z][y][x]);
}}}
//****************************************************************************
calclabel();
for(z = 0;z <(nlin);z++){
for(y = 0;y <(nlin);y++){           
for(x = 0;x <(nlin);x++){
label = cl[z][y][x];
if(label > 0){
label = proper(label);
cl[z][y][x] = label;
}
//printf("cl[%d][%d][%d] ist: %d\n",z,y,x,cl[z][y][x]);
}}}
/*******************************************************/  
Xmax=1;
for(z = 0;z <(nlin);z++){
for(y = 0;y <(nlin);y++){           
for(x = 0;x <(nlin);x++){
if(cl[z][y][x]>Xmax){Xmax=cl[z][y][x];}}}}
for(l = 1;l <=Xmax ;l++){
h[l]=0;}
for(l = 1;l <=Xmax ;l++){
for(z = 0;z <(nlin);z++){
for(y = 0;y <(nlin);y++){           
for(x = 0;x <(nlin);x++){
if(cl[z][y][x]==l){h[l]= h[l]+1;}}}}}
Hmax=0;
for(l = 1;l <=Xmax ;l++){
if(h[l]>Hmax){Hmax=h[l];}}
Hmax1=0;
for(l = 1;l <=Xmax ;l++){
if((h[l]>Hmax1)&&(h[l]!=Hmax)){Hmax1=h[l];}}
for(i = 1;i <=Xmax ;i++){
if(h[i]==Hmax)
ll=i;}
for(j = 1;j <=Xmax ;j++){
if(h[j]==Hmax1)
lll=j;}
/*******************************************************/  
          hhhh_x=0;
for(z = 0;z <(nlin);z++){
for(y = 0;y <(nlin);y++){           
for(x = 0;x <(nlin);x++){
          if((cl[z][0][y]==ll)&&(cl[z][nlin-1][x]==ll)){hhhh_x+=1;}
          }
          }
	  }
          if(hhhh_x!=0){printf("Der Label des unendlichen Clusters der %d-ten Konfiguration  ist links,rechts: %d\n",k,ll);h_k_x+=1;summe_c[k]+=1;}
          else if(hhhh_x==0){printf("Es gibt bei der %d-ten Konfiguration  keinen unendlichen Cluster links,rechts\n",k);}
        hhhh_y=0;
for(z = 0;z <(nlin);z++){
for(y = 0;y <(nlin);y++){           
for(x = 0;x <(nlin);x++){
          if((cl[z][y][0]==ll)&&(cl[z][x][nlin-1]==ll)){hhhh_y+=1;}
          }
          }
	  }
	  if(hhhh_y!=0){printf("Der Label des unendlichen Clusters der %d-ten Konfiguration  ist oben,unten: %d\n",k,ll);h_k_y+=1;summe_c[k]+=1;}
	  else if(hhhh_y==0){printf("Es gibt bei der %d-ten Konfiguration  keinen unendlichen Cluster oben,unten\n",k);}
	 hhhh_z=0;
for(z = 0;z <(nlin);z++){
for(y = 0;y <(nlin);y++){           
for(x = 0;x <(nlin);x++){
          if((cl[0][y][x]==ll)&&(cl[y][nlin-1][x]==ll)){hhhh_z+=1;}
          }
          }
	  }
	  if(hhhh_z!=0){printf("Der Label des unendlichen Clusters der %d-ten Konfiguration  ist vorne,hinter: %d\n",k,ll);h_k_z+=1;summe_c[k]+=1;}
	  else if(hhhh_z==0){printf("Es gibt bei der %d-ten Konfiguration  keinen unendlichen Cluster vorne,hinter\n",k);}

/*******************************************************/  
 

 

return 0;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
/* Unterprogramme */ 

void Start_Zufallszahlen(int seed)		// Kirkpatrick-Stoll-ZZgenerator
{ 
	Jitoz = 0;
	Jdimax = 1. / Jiadd;
   	lm = 2 * seed + 1;	
   	for (i = 0; i < 250; i++)	{ 
		lm *= Jmult;
     		if (lm < 0) 
			lm += Jiadd + 1;
		Jmz[i] = lm;		    		
	}
}  
/* end of Start_Zufallszahlen() */
/*******************************************************************/					
void Gauss_Verteilung()
{
int x,y;
double y3[nlin*nlin*nlin],v1, v2, w,ave_x, var_x;
	ave_x = 0.0;					// neue Initialisierungen
	v1 =	0.0;
	v2 =	0.0;
	w =	0.0;
	lm = 	0;					// Groesse aus Start_Zufallszahlen !

	for(i = 0; i < nlin*nlin*nlin; i++)	{
		x1[i] = y3[i] = 0.0;
	}	
			
	for(i = 0; i < nlin*nlin*nlin; i++)	{			// Verbess. der Gauss-Vert. durch ZGS.
		for(j = 0; j < 9; j++)	{		// ** (siehe Ende der Schleife)
			y3[j] = 0.0;
			do	{
				Jitoz = (Jitoz + 1) % 250;
				Jmz[Jitoz] ^= Jmz[(Jitoz + 103) % 250];	// fuer jede Nummer
				v1 = 2.0 * Jmz[Jitoz] * Jdimax - 1.0;	// gleichvert.Var.1

	   			Jitoz = (Jitoz + 1) % 250;
				Jmz[Jitoz] ^= Jmz[(Jitoz + 103) % 250];	// fuer jede Nummer
				v2 = 2.0 * Jmz[Jitoz] * Jdimax - 1.0;	// gleichvert.Var.1

				w = v1*v1 + v2*v2;			
			}
			while(w >= 1.0);		// Varianzabfrage
			w = sqrt((-2.0 * log(w)/w));
			y3[j] = v1 * w;			// Gauss-verteilt mit Var.1
			x1[i] += y3[j];
		}
		x1[i] = x1[i]/3.0;			// gehoert zu **
		//printf("%d\t %f\n", i, (x1[i]));
		ave_x += x1[i];				// Summe zur Mittelwertbildung
	}
	ave_x /= (double)(nlin*nlin*nlin);
	//printf("x-Mittel (unkorreliert)	= %f\n", ave_x);
	ave_x = 0.0;

for(i = 0;i<(nlin);i++){  
for(j = 0;j<(nlin);j++){                                                                                
for(k = 0;k<(nlin);k++){
lattice[i][j][k]=x1[j*nlin+i*nlin*nlin+k];
//printf("lattice[%d][%d][%d] %f\n",i,j,k,lattice[i][j][k]);
}}}	
}



